
#include <stdio.h>

#define ARRAY_SIZE_1 2000
#define REPETITION 1000000

#define LOOP_0
#define LOOP_1
#define LOOP_2
#define LOOP_3

#define FTYPE float

#define ALIGN_BOUNDARY 32 
#define OFFSET 0

typedef struct{
	#ifdef _WIN32
		_declspec(align(ALIGN_BOUNDARY, OFFSET)) FTYPE a;
		_declspec(align(ALIGN_BOUNDARY, OFFSET)) FTYPE b;
	#else
		FTYPE a	__attribute__((align(ALIGN_BOUNDARY, OFFSET)));
		FTYPE b __attribute__((align(ALIGN_BOUNDARY, OFFSET));
	#endif // _WIN32		
} AoS;

AoS   AoS_x[ARRAY_SIZE_1];
FTYPE AoS_y[ARRAY_SIZE_1];

typedef struct{
	#ifdef _WIN32
		_declspec(align(ALIGN_BOUNDARY, OFFSET)) FTYPE a[ARRAY_SIZE_1];
		_declspec(align(ALIGN_BOUNDARY, OFFSET)) FTYPE b[ARRAY_SIZE_1];
	#else
		FTYPE a[ARRAY_SIZE_1]	__attribute__((align(ALIGN_BOUNDARY, OFFSET)));
		FTYPE b[ARRAY_SIZE_1] __attribute__((align(ALIGN_BOUNDARY, OFFSET));
	#endif // _WIN32		
} SoA;

SoA   SoA_x;
FTYPE SoA_y[ARRAY_SIZE_1];

SoA   SoA_x_2;
FTYPE SoA_y_2[ARRAY_SIZE_1];

typedef struct{
	#ifdef _WIN32
		_declspec(align(ALIGN_BOUNDARY, OFFSET)) FTYPE a[ARRAY_SIZE_1/2];
		_declspec(align(ALIGN_BOUNDARY, OFFSET)) FTYPE b[ARRAY_SIZE_1/2];
	#else
		FTYPE a[ARRAY_SIZE_1/2]	__attribute__((align(ALIGN_BOUNDARY, OFFSET)));
		FTYPE b[ARRAY_SIZE_1/2] __attribute__((align(ALIGN_BOUNDARY, OFFSET));
	#endif // _WIN32		
} A_SoA;

A_SoA A_SoA_x[2];
FTYPE A_SoA_y[ARRAY_SIZE_1];


int main(){

/**
	for(int i = 0; i < ARRAY_SIZE_1; i++){
		y[i] = 0;
		x[i].a = 0;
		x[i].b = 0;	
	}
*/

	printf("hello \n");
	
#ifdef LOOP_0
for(int j = 0; j < REPETITION; j++){
	for(int i = 0; i < ARRAY_SIZE_1; i++){
		
		AoS_y[i] = AoS_x[i].a + AoS_x[i].b;	
	}
}
	printf("loop 0 \n");
#endif	

#ifdef LOOP_1
for(int j = 0; j < REPETITION; j++){
	for(int i = 0; i < ARRAY_SIZE_1; i++){
		SoA_y[i] = SoA_x.a[i] + SoA_x.b[i];	
	}
}
		printf("loop 1 \n");
#endif

#ifdef LOOP_2
for(int j = 0; j < REPETITION; j++){
	int m = 0;
	for(int k = 0; k < 2; k++){
		for(int i = 0; i < ARRAY_SIZE_1/2; i++){
			A_SoA_y[m] = A_SoA_x[k].a[i] + A_SoA_x[k].b[i];	
			m++;
		}
	}
}
		printf("loop 2 \n");
#endif

#ifdef LOOP_3
for(int j = 0; j < REPETITION; j++){

	for(int i = 0; i < ARRAY_SIZE_1; i++){
		SoA_y_2[i] = SoA_x_2.a[i] + SoA_x_2.a[i] + SoA_x_2.b[i] + SoA_x_2.b[i] + SoA_x_2.b[i];	
	}
}
		printf("loop 3 \n");
#endif





return 0;
}
